!      program amortecimento
! use msflib ! biblioteca que contem o comando systemqq

! logical chamada

	implicit real *8 (a-h,o-z)
	parameter (nelmax=100)
	dimension tp(nelmax)
	external fcn,rkqc
      common /const/ ht2 
      open(1,file='inpaula.txt')
	open(2,file='x1.txt')
	open(3,file='x-all.txt')
!
!	integrador de EDO's com passo adaptativo - RK 4a/5a ordem
!	integrador de EDO's com passo fixo - RK 4a ordem  e For. Euler
!
	read(1,*)iflag
	write(*,*)'iflag=',iflag
	read(1,*)n,tau0
	write(*,*)'n=',n,'tau0=',tau0
	read(1,*) tend,dtau
	write(*,*)'tend=',tend,'dtau=',dtau
!
!	initial values
!
		read(1,*)(tp(l),l=1,n)
		write(*,*)(tp(l),l=1,n)

!	initial time

	time=tau0

	k=0 
	write(3,*) '     Table of results'
	write(3,*)'-----------------------------'
	write(3,*)'  Passo Nr     time       T(i)    '
	write(3,*)'-----------------------------'
	write(3,*)k,time,(tp(l),l=1,n)
	write(2,*)time,tp(1)
	ht2=dtau/100
!
!	beginning of time loop
!
 50	k=k+1 
	tendi=time+dtau
      	write(*,*)'-------------time=',tendi
	if(iflag.eq.0) then	! RK-adaptativo
     call odeint(tp,n,time,tendi,1.e-6,ht2,1.e-20,id1,id2,nelmax,fcn,rkqc)
	endif
	if(iflag.eq.1) then	 ! RK-passo fixo
	      kk=0 
 500	  kk=kk+1 
		time=min(time+ht2,tendi) 
		call  rk4ord(tp,n,time,ht2,fcn,nelmax)	
		if (time.lt.tendi) goto 500 
	endif
	if(iflag.eq.2) then	  ! Forward Euler
	    call fore(n,fcn,time,tp,tendi,nelmax)
	endif
	write(3,*)k,tendi,(tp(l),l=1,n)
	write(2,*)tendi,tp(1)
     	if (tendi.lt.tend) then
			time=tendi
			goto 50 
		endif
	close(2)
	close(3)
	close(4)

call system('notepad x-all.txt')       ! listagem de todas as variaveis
! chamada = systemqq('notepad x2.txt')       ! listagem 2a variavel


call system('wgnuplot dados.gnu')  ! grfico	geral
	stop
	end
!**************************************
	subroutine fcn(n,t,fi,f,nelmax)
	implicit real *8 (a-h,o-z)
	dimension fi(nelmax),f(nelmax)


	!	Exercicio 7.19 do livro Calc Num Aplicado
	!	listagem de parametros

		rmc=50.
		cc=870.
		u=10.
		ac=100.
		tinf=298.
		alfa=0.9
		epsilon=0.9
		sig=5.67d-8
		tceu=292.
		ri=500.

   !	A equacao diferencial ordinaria - derivada de T_c

	f(1)=(u*ac*(tinf-fi(1))+ac*(alfa*ri+epsilon*sig*(tceu**4-fi(1)**4)))/rmc/cc


	return
	end
!***************************************
!234567890123456789012345678901234567890123456789012345678901234567890 
      subroutine fore(n,fcn,time,fi,tend,nelmax) 
! 
      implicit real *8 (a-h,o-z)
      parameter (nd1=100) 
      dimension fi(nelmax),f(nd1)
      common /const/ ht2 
      external fcn 
      k=0 
 50   k=k+1 
      time=min(time+ht2,tend) 
      call fcn(n,time,fi,f,nelmax) 
      do 100 i=1,n 
         fi(i)=fi(i)+ht2*f(i) 
 100  continue 
      if (time.lt.tend) goto 50 
      return 
      end 
!------------------------------------------------------------------ 





