!***************************************
!234567890123456789012345678901234567890123456789012345678901234567890 
      subroutine rk4feadap(n,fcn,time,fi,tend,nelmax) 
! 
      implicit real *8 (a-h,o-z)
      parameter (nd1=100) 
      dimension fi(nelmax),fife(nd1)
	  common /foreu/ ffe(nd1)
      common /const/ ht2 
	  common /adap/ alfa,p,tol
  	  common /passo/ h

      external fcn 

      k=0 
	  h=ht2
!-------------Beginning of integration loop from time to tend
 50   k=k+1 
      time=min(time+h,tend) 

!	armazena a soluo em time para o mtodo de Euler
	  do i=1,n
		fife(i)=fi(i)
	  enddo
!	compute solution @ time+h with RK4
	  call  rk4ord(fi,n,time,h,fcn,nelmax)	

!	compute solution @ time+h with Forward Euler
      do 100 i=1,n 
         fife(i)=fife(i)+h*ffe(i) 
 100  continue 
 !----------------------------------------------------------- 
      erroint=0.0
      do j=1, n
		erroint=erroint+abs(fife(j)-fi(j))/fi(j)
      enddo
      etl=erroint/n
 !----------------------------------------------------------- 
!	if(etl.le.tol) then
!		h=2*h
!	else
!		h=0.5*h
!	endif


	h=alfa*h*(abs((tol)/etl))**(1./(1.+p))

 !	write(8,*)'h = ',h

      if (time.lt.tend) goto 50 
      return 
      end 
!------------------------------------------------------------------ 
