!***************************************
!234567890123456789012345678901234567890123456789012345678901234567890 
      subroutine rk4feadap(n,fcn,time,fi,tend,nelmax) 
! 
!      implicit real *8 (a-h,o-z)
      parameter (nd1=100) 
      dimension fi(nelmax),f(nd1),fife(nd1)
      common /const/ ht2 
  	  common /adap/ alfa,p,tolfe1,tolfe2,tol

      external fcn 

      k=0 
	  h=ht2
!-------------Beginning of integration loop from time to tend
 50   k=k+1 
		tant=time
		auxtime=time+h
		if(tend.le.auxtime) then
			time=tend
			hdif=tend-tant
		else
			time=auxtime
			hdif=h
		endif

!	compute solution @ time with RK4-fixed step
	  do i=1,n
		fife(i)=fi(i)
	  enddo
	  call  rk4ord(fi,n,tant,hdif,fcn,nelmax)	

!	compute solution @ time with Forward Euler

	call fore(n,fcn,tant,fife,time,nelmax)
 !----------------------------------------------------------- 
      erroint=0.0
      do j=1, n
		erroint=erroint+abs(fife(j)-fi(j))  ! /fi(j))
      enddo
      etl=erroint/n
 !----------------------------------------------------------- 

	if(etl.gt.tolfe2.and.etl.le.tolfe1) then
		h=alfa*h*(abs((tol)/etl))**(1./(1.+p))

!	if(etl.le.tolfe1) then
!		h=2*h
!	else
!		h=0.5*h
!	endif
	endif		


      if (time.lt.tend) goto 50 

      return 
      end 
!------------------------------------------------------------------ 
