!
!  programa de interpolao polinomial
!
!
      parameter(nmax=25)   
      dimension c(0:nmax,0:nmax),x(0:nmax)
!
!     arquivo de entrada com os valores x_i e f(x_i)
!
      open (9,file='inptab.dat')
!
!     arquivo de sada com a curva interpolada
!
      open (3,file='outcarro.dat') 
      open (4,file='out-pontos.dat') 
!
!****************************************
!	Leitura do nmero de pontos dados (ndados+1) e do numero
!	de pontos a utilizar na construo da curva interpolada 
!****************************************
!
      read(9,*) ndados,npontos
      write(*,*)'ndados=',ndados,'npontos=',npontos

!
!******************************
!
!
!     ler pontos dados a interpolar
!
      do i=0,ndados
         read(9,*) x(i),c(i,0)
         write(4,*) x(i),c(i,0)
      enddo
!
!	calcular coeficientes do polinomio de grau ndados
!
	do j=1,ndados
		do i=0,ndados-j
			c(i,j)=(c(i+1,j-1)-c(i,j-1))/(x(i+j)-x(i))
		enddo
	enddo
!
!	calcular os npontos do polinomio 
!	interpolado	(os pontos devem estar em ordem crescente de x)
!
	dx=(x(ndados)-x(0))/npontos
	xi=x(0)
	do ir=1,npontos+1
		sum=0.
		do i=0,ndados
			prod=1.
			if(i.gt.0) then
				do j=0,i-1
					prod=prod*(xi-x(j))
				enddo
			endif	
			sum=sum+c(0,i)*prod
		enddo
		write(3,*)xi,sum
		xi=xi+dx
	enddo
	write(*,*)(c(0,i),i=0,ndados)
close(3)
close(4)

call system('notepad outcarro.dat')       ! listagem dos dados
call system('notepad out-pontos.dat')       ! listagem dos dados

 call system('wgnuplot dados.gnu')  ! grfico
      stop
      end



